import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
/**
 * Insert the type's description here.
 * Creation date: (8/22/2002 10:19:21 PM)
 * @author: Administrator
 */
//class TraceViewerCellRenderer extends javax.swing.JLabel implements javax.swing.table.TableCellRenderer
class TraceViewerCellRenderer extends javax.swing.table.DefaultTableCellRenderer
{
	private boolean					isSelected;
	private boolean					hasFocus;
	private TraceViewerDataModel	model;
	private TraceViewer				trcViewer;
	private ImageIcon[]				images;
/**
 * TraceViewerCellRenderer constructor comment.
 */
public TraceViewerCellRenderer()
{
    super();
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/2002 10:22:07 PM)
 * @param param int
 */
public TraceViewerCellRenderer(TraceViewer trcViewer, TraceViewerDataModel model)
{
	this.model		= model;
	this.trcViewer	= trcViewer;
	
	// Create all of the images
	images = new ImageIcon[2];
	images[0] = new javax.swing.ImageIcon(getClass().getResource("/unchecked.gif"));
	images[1] = new javax.swing.ImageIcon(getClass().getResource("/checked.gif"));
}
/**
 *  This method is sent to the renderer by the drawing table to
 *  configure the renderer appropriately before drawing.  Return
 *  the Component used for drawing.
 *
 * @param	table		the JTable that is asking the renderer to draw.
 *					This parameter can be null.
 * @param	value		the value of the cell to be rendered.  It is
 *				up to the specific renderer to interpret
 *				and draw the value.  eg. if value is the
 *				String "true", it could be rendered as a
 *				string or it could be rendered as a check
 *				box that is checked.  null is a valid value.
 * @param	isSelected	true is the cell is to be renderer with
 *				selection highlighting
 * @param	row	        the row index of the cell being drawn.  When
 *				drawing the header the rowIndex is -1.
 * @param	column	        the column index of the cell being drawn
 */
public Component getTableCellRendererComponent(
    JTable table,
    Object value,
    boolean isSelected,
    boolean hasFocus,
    int row,
    int column)
{
	this.isSelected = isSelected;
    this.hasFocus = hasFocus;

	// Get a reference to the current cell and set its color.
	Component cell = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
	if (trcViewer.getVBip().get(row).toString().equals("BIP6060I") && column > 0)
		cell.setForeground(new Color(0, 200, 0));
	else if (trcViewer.getVBip().get(row).toString().substring(7).equals("E") && column > 0)
		cell.setForeground(new Color(255, 0, 0));
	else if (trcViewer.getVBip().get(row).toString().equals("BIP4060I") && column > 0)
		cell.setForeground(new Color(0, 0, 255));
	else
		cell.setForeground(Color.black);

    // Set the preferred background colors.
    if(isSelected)
    	cell.setBackground(Color.lightGray);
    else
    	cell.setBackground(Color.white);
		
    if(hasFocus)
    	cell.setBackground(Color.lightGray);
	
	// At this point set the image based on the row value and whether 
	// the bookmark linkedlist has a value.
    switch(column)
    {
    	case 0:
	  		if (trcViewer.getBkMark().contains(new Integer(row)))
    			setIcon(images[1]);
    		else
    			setIcon(images[0]);
    		break;
    	case 1:
			setText(trcViewer.getVThread().get(row).toString());
			setHorizontalAlignment(CENTER);
			break;
    	case 2:
			setText(trcViewer.getVBip().get(row).toString().substring(3));
			setHorizontalAlignment(CENTER);
			break;
    	case 3:
			setText(trcViewer.getVShortText().get(row).toString());
			break;
    }
	cell.repaint();
	return cell;
}
/**
 * Insert the method's description here.
 * Creation date: (8/15/2002 9:52:43 PM)
 * @param g java.awt.Graphics
 */
public void paint(Graphics g)
{
	// This is a hack to paint the background.  Normally, a JLabel can
	// paint its own background, but due to an apparent bug or
	// limitation in the TableCellRenderer, the paint method is
	// required to handle this.
	Color	bColor;

	// Set the correct background color
	if(isSelected || hasFocus)
		bColor = Color.lightGray;
	else
		bColor = Color.white;

	g.setColor(bColor);

	// Draw a rectangle in the background of this cell
 	g.fillRect(0, 0, getWidth() -1, getHeight() - 1);

	super.paint(g);
}
}
